Index: include/avr/iom645.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom645.h,v
retrieving revision 1.17
diff -u -r1.17 iom645.h
--- include/avr/iom645.h	11 Feb 2009 17:53:37 -0000	1.17
+++ include/avr/iom645.h	26 Mar 2009 20:10:33 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2004,2005,2006 Eric B. Weddington
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -671,86 +672,107 @@
 /* Interrupt vectors */
 /* Vector 0 is the reset vector */
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* Pin Change Interrupt Request 0 */
+#define PCINT0_num 			2
 #define PCINT0_vect			_VECTOR(2)
 #define SIG_PIN_CHANGE0			_VECTOR(2)
 
 /* Pin Change Interrupt Request 1 */
+#define PCINT1_num 			3
 #define PCINT1_vect			_VECTOR(3)
 #define SIG_PIN_CHANGE1			_VECTOR(3)
 
 /* Timer/Counter2 Compare Match */
+#define TIMER2_COMP_num 		4
 #define TIMER2_COMP_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE2		_VECTOR(4)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			5
 #define TIMER2_OVF_vect			_VECTOR(5)
 #define SIG_OVERFLOW2			_VECTOR(5)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		6
 #define TIMER1_CAPT_vect		_VECTOR(6)
 #define SIG_INPUT_CAPTURE1		_VECTOR(6)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		7
 #define TIMER1_COMPA_vect		_VECTOR(7)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(7)
 
 /* Timer/Counter Compare Match B */
+#define TIMER1_COMPB_num 		8
 #define TIMER1_COMPB_vect		_VECTOR(8)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(8)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			9
 #define TIMER1_OVF_vect			_VECTOR(9)
 #define SIG_OVERFLOW1			_VECTOR(9)
 
 /* Timer/Counter0 Compare Match */
+#define TIMER0_COMP_num 		10
 #define TIMER0_COMP_vect		_VECTOR(10)
 #define SIG_OUTPUT_COMPARE0		_VECTOR(10)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			11
 #define TIMER0_OVF_vect			_VECTOR(11)
 #define SIG_OVERFLOW0			_VECTOR(11)
 
 /* SPI Serial Transfer Complete */
+#define SPI_STC_num 			12
 #define SPI_STC_vect			_VECTOR(12)
 #define SIG_SPI				_VECTOR(12)
 
 /* USART0, Rx Complete */
+#define USART0_RX_num 			13
 #define USART0_RX_vect			_VECTOR(13)
 #define SIG_UART_RECV			_VECTOR(13)
 
 /* USART0 Data register Empty */
+#define USART0_UDRE_num 		14
 #define USART0_UDRE_vect		_VECTOR(14)
 #define SIG_UART_DATA			_VECTOR(14)
 
 /* USART0, Tx Complete */
+#define USART0_TX_num 			15
 #define USART0_TX_vect			_VECTOR(15)
 #define SIG_UART_TRANS			_VECTOR(15)
 
 /* USI Start Condition */
+#define USI_START_num 			16
 #define USI_START_vect			_VECTOR(16)
 #define SIG_USI_START			_VECTOR(16)
 
 /* USI Overflow */
+#define USI_OVERFLOW_num 		17
 #define USI_OVERFLOW_vect		_VECTOR(17)
 #define SIG_USI_OVERFLOW		_VECTOR(17)
 
 /* Analog Comparator */
+#define ANALOG_COMP_num 		18
 #define ANALOG_COMP_vect		_VECTOR(18)
 #define SIG_COMPARATOR			_VECTOR(18)
 
 /* ADC Conversion Complete */
+#define ADC_num 			19
 #define ADC_vect			_VECTOR(19)
 #define SIG_ADC				_VECTOR(19)
 
 /* EEPROM Ready */
+#define EE_READY_num 			20
 #define EE_READY_vect			_VECTOR(20)
 #define SIG_EEPROM_READY		_VECTOR(20)
 
 /* Store Program Memory Read */
+#define SPM_READY_num 			21
 #define SPM_READY_vect			_VECTOR(21)
 #define SIG_SPM_READY			_VECTOR(21)
 
@@ -813,4 +835,241 @@
 #define SIGNATURE_2 0x05
 
 
+/* Device Pin Definitions */
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	0
+
+#define DDR_PCINT8  	DDRB
+#define PORT_PCINT8 	PORTB
+#define PIN_PCINT8  	PINB
+#define PCINT8_IDX  	0
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	1
+
+#define DDR_PCINT9  	DDRB
+#define PORT_PCINT9 	PORTB
+#define PIN_PCINT9  	PINB
+#define PCINT9_IDX  	1
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	2
+
+#define DDR_PCINT10  	DDRB
+#define PORT_PCINT10 	PORTB
+#define PIN_PCINT10  	PINB
+#define PCINT10_IDX  	2
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	3
+
+#define DDR_PCINT11  	DDRB
+#define PORT_PCINT11 	PORTB
+#define PIN_PCINT11  	PINB
+#define PCINT11_IDX  	3
+
+#define DDR_OC0A  	DDRB
+#define PORT_OC0A 	PORTB
+#define PIN_OC0A  	PINB
+#define OC0A_IDX  	4
+
+#define DDR_PCINT12  	DDRB
+#define PORT_PCINT12 	PORTB
+#define PIN_PCINT12  	PINB
+#define PCINT12_IDX  	4
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	5
+
+#define DDR_PCINT13  	DDRB
+#define PORT_PCINT13 	PORTB
+#define PIN_PCINT13  	PINB
+#define PCINT13_IDX  	5
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	6
+
+#define DDR_PCINT14  	DDRB
+#define PORT_PCINT14 	PORTB
+#define PIN_PCINT14  	PINB
+#define PCINT14_IDX  	6
+
+#define DDR_OC2A  	DDRB
+#define PORT_OC2A 	PORTB
+#define PIN_OC2A  	PINB
+#define OC2A_IDX  	7
+
+#define DDR_PCINT15  	DDRB
+#define PORT_PCINT15 	PORTB
+#define PIN_PCINT15  	PINB
+#define PCINT15_IDX  	7
+
+#define DDR_ICP1  	DDRD
+#define PORT_ICP1 	PORTD
+#define PIN_ICP1  	PIND
+#define ICP1_IDX  	0
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	1
+
+#define DDR_RXD  	DDRE
+#define PORT_RXD 	PORTE
+#define PIN_RXD  	PINE
+#define RXD_IDX  	0
+
+#define DDR_PCINT0  	DDRE
+#define PORT_PCINT0 	PORTE
+#define PIN_PCINT0  	PINE
+#define PCINT0_IDX  	0
+
+#define DDR_TXD  	DDRE
+#define PORT_TXD 	PORTE
+#define PIN_TXD  	PINE
+#define TXD_IDX  	1
+
+#define DDR_PCINT1  	DDRE
+#define PORT_PCINT1 	PORTE
+#define PIN_PCINT1  	PINE
+#define PCINT1_IDX  	1
+
+#define DDR_XCK  	DDRE
+#define PORT_XCK 	PORTE
+#define PIN_XCK  	PINE
+#define XCK_IDX  	2
+
+#define DDR_AIN0  	DDRE
+#define PORT_AIN0 	PORTE
+#define PIN_AIN0  	PINE
+#define AIN0_IDX  	2
+
+#define DDR_PCINT2  	DDRE
+#define PORT_PCINT2 	PORTE
+#define PIN_PCINT2  	PINE
+#define PCINT2_IDX  	2
+
+#define DDR_AIN1  	DDRE
+#define PORT_AIN1 	PORTE
+#define PIN_AIN1  	PINE
+#define AIN1_IDX  	3
+
+#define DDR_PCINT3  	DDRE
+#define PORT_PCINT3 	PORTE
+#define PIN_PCINT3  	PINE
+#define PCINT3_IDX  	3
+
+#define DDR_USCK  	DDRE
+#define PORT_USCK 	PORTE
+#define PIN_USCK  	PINE
+#define USCK_IDX  	4
+
+#define DDR_SCL  	DDRE
+#define PORT_SCL 	PORTE
+#define PIN_SCL  	PINE
+#define SCL_IDX  	4
+
+#define DDR_PCINT4  	DDRE
+#define PORT_PCINT4 	PORTE
+#define PIN_PCINT4  	PINE
+#define PCINT4_IDX  	4
+
+#define DDR_DI  	DDRE
+#define PORT_DI 	PORTE
+#define PIN_DI  	PINE
+#define DI_IDX  	5
+
+#define DDR_SDA  	DDRE
+#define PORT_SDA 	PORTE
+#define PIN_SDA  	PINE
+#define SDA_IDX  	5
+
+#define DDR_PCINT5  	DDRE
+#define PORT_PCINT5 	PORTE
+#define PIN_PCINT5  	PINE
+#define PCINT5_IDX  	5
+
+#define DDR_DO  	DDRE
+#define PORT_DO 	PORTE
+#define PIN_DO  	PINE
+#define DO_IDX  	6
+
+#define DDR_PCINT6  	DDRE
+#define PORT_PCINT6 	PORTE
+#define PIN_PCINT6  	PINE
+#define PCINT6_IDX  	6
+
+#define DDR_CLKO  	DDRE
+#define PORT_CLKO 	PORTE
+#define PIN_CLKO  	PINE
+#define CLKO_IDX  	7
+
+#define DDR_PCINT7  	DDRE
+#define PORT_PCINT7 	PORTE
+#define PIN_PCINT7  	PINE
+#define PCINT7_IDX  	7
+
+#define DDR_ADC0  	DDRF
+#define PORT_ADC0 	PORTF
+#define PIN_ADC0  	PINF
+#define ADC0_IDX  	0
+
+#define DDR_ADC1  	DDRF
+#define PORT_ADC1 	PORTF
+#define PIN_ADC1  	PINF
+#define ADC1_IDX  	1
+
+#define DDR_ADC2  	DDRF
+#define PORT_ADC2 	PORTF
+#define PIN_ADC2  	PINF
+#define ADC2_IDX  	2
+
+#define DDR_ADC3  	DDRF
+#define PORT_ADC3 	PORTF
+#define PIN_ADC3  	PINF
+#define ADC3_IDX  	3
+
+#define DDR_ADC4  	DDRF
+#define PORT_ADC4 	PORTF
+#define PIN_ADC4  	PINF
+#define ADC4_IDX  	4
+
+#define DDR_ADC5  	DDRF
+#define PORT_ADC5 	PORTF
+#define PIN_ADC5  	PINF
+#define ADC5_IDX  	5
+
+#define DDR_ADC6  	DDRF
+#define PORT_ADC6 	PORTF
+#define PIN_ADC6  	PINF
+#define ADC6_IDX  	6
+
+#define DDR_ADC7  	DDRF
+#define PORT_ADC7 	PORTF
+#define PIN_ADC7  	PINF
+#define ADC7_IDX  	7
+
+#define DDR_T1  	DDRG
+#define PORT_T1 	PORTG
+#define PIN_T1  	PING
+#define T1_IDX  	3
+
+#define DDR_T0  	DDRG
+#define PORT_T0 	PORTG
+#define PIN_T0  	PING
+#define T0_IDX  	4
+
+
 #endif /* _AVR_IOM645_H_ */
Index: include/avr/iom32hvb.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom32hvb.h,v
retrieving revision 1.8
diff -u -r1.8 iom32hvb.h
--- include/avr/iom32hvb.h	11 Feb 2009 17:53:36 -0000	1.8
+++ include/avr/iom32hvb.h	26 Mar 2009 20:10:32 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2007 Atmel Corporation
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -812,33 +813,61 @@
 /* Interrupt Vectors */
 /* Interrupt Vector 0 is the reset vector. */
 
+#define BPINT_num          1
 #define BPINT_vect         _VECTOR(1)  /* Battery Protection Interrupt */
+#define VREGMON_num        2
 #define VREGMON_vect       _VECTOR(2)  /* Voltage regulator monitor interrupt */
+#define INT0_num           3
 #define INT0_vect          _VECTOR(3)  /* External Interrupt Request 0 */
+#define INT1_num           4
 #define INT1_vect          _VECTOR(4)  /* External Interrupt Request 1 */
+#define INT2_num           5
 #define INT2_vect          _VECTOR(5)  /* External Interrupt Request 2 */
+#define INT3_num           6
 #define INT3_vect          _VECTOR(6)  /* External Interrupt Request 3 */
+#define PCINT0_num         7
 #define PCINT0_vect        _VECTOR(7)  /* Pin Change Interrupt 0 */
+#define PCINT1_num         8
 #define PCINT1_vect        _VECTOR(8)  /* Pin Change Interrupt 1 */
+#define WDT_num            9
 #define WDT_vect           _VECTOR(9)  /* Watchdog Timeout Interrupt */
+#define BGSCD_num          10
 #define BGSCD_vect         _VECTOR(10)  /* Bandgap Buffer Short Circuit Detected */
+#define CHDET_num          11
 #define CHDET_vect         _VECTOR(11)  /* Charger Detect */
+#define TIMER1_IC_num      12
 #define TIMER1_IC_vect     _VECTOR(12)  /* Timer 1 Input capture */
+#define TIMER1_COMPA_num   13
 #define TIMER1_COMPA_vect  _VECTOR(13)  /* Timer 1 Compare Match A */
+#define TIMER1_COMPB_num   14
 #define TIMER1_COMPB_vect  _VECTOR(14)  /* Timer 1 Compare Match B */
+#define TIMER1_OVF_num     15
 #define TIMER1_OVF_vect    _VECTOR(15)  /* Timer 1 overflow */
+#define TIMER0_IC_num      16
 #define TIMER0_IC_vect     _VECTOR(16)  /* Timer 0 Input Capture */
+#define TIMER0_COMPA_num   17
 #define TIMER0_COMPA_vect  _VECTOR(17)  /* Timer 0 Comapre Match A */
+#define TIMER0_COMPB_num   18
 #define TIMER0_COMPB_vect  _VECTOR(18)  /* Timer 0 Compare Match B */
+#define TIMER0_OVF_num     19
 #define TIMER0_OVF_vect    _VECTOR(19)  /* Timer 0 Overflow */
+#define TWIBUSCD_num       20
 #define TWIBUSCD_vect      _VECTOR(20)  /* Two-Wire Bus Connect/Disconnect */
+#define TWI_num            21
 #define TWI_vect           _VECTOR(21)  /* Two-Wire Serial Interface */
+#define SPI_STC_num        22
 #define SPI_STC_vect       _VECTOR(22)  /* SPI Serial transfer complete */
+#define VADC_num           23
 #define VADC_vect          _VECTOR(23)  /* Voltage ADC Conversion Complete */
+#define CCADC_CONV_num     24
 #define CCADC_CONV_vect    _VECTOR(24)  /* Coulomb Counter ADC Conversion Complete */
+#define CCADC_REG_CUR_num  25
 #define CCADC_REG_CUR_vect _VECTOR(25)  /* Coloumb Counter ADC Regular Current */
+#define CCADC_ACC_num      26
 #define CCADC_ACC_vect     _VECTOR(26)  /* Coloumb Counter ADC Accumulator */
+#define EE_READY_num       27
 #define EE_READY_vect      _VECTOR(27)  /* EEPROM Ready */
+#define SPM_num            28
 #define SPM_vect           _VECTOR(28)  /* SPM Ready */
 
 #define _VECTORS_SIZE (29 * 4)
@@ -882,4 +911,6 @@
 #define __LOCK_BITS_EXIST
 
 
+/* Device Pin Definitions */
+
 #endif  /* _AVR_IOM32HVB_H_ */
Index: include/avr/iom406.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom406.h,v
retrieving revision 1.9
diff -u -r1.9 iom406.h
--- include/avr/iom406.h	11 Feb 2009 17:53:37 -0000	1.9
+++ include/avr/iom406.h	26 Mar 2009 20:10:32 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2006, Pieter Conradie
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -636,89 +637,111 @@
 
 /* Interrupt vectors */
 /* Battery Protection Interrupt */
+#define BPINT_num 			1
 #define BPINT_vect			_VECTOR(1)
 
 
 /* External Interrupt Request 0 */
+#define INT0_num 			2
 #define INT0_vect			_VECTOR(2)
 
 
 /* External Interrupt Request 1 */
+#define INT1_num 			3
 #define INT1_vect			_VECTOR(3)
 
 
 /* External Interrupt Request 2 */
+#define INT2_num 			4
 #define INT2_vect			_VECTOR(4)
 
 
 /* External Interrupt Request 3 */
+#define INT3_num 			5
 #define INT3_vect			_VECTOR(5)
 
 
 /* Pin Change Interrupt 0 */
+#define PCINT0_num 			6
 #define PCINT0_vect			_VECTOR(6)
 
 
 /* Pin Change Interrupt 1 */
+#define PCINT1_num 			7
 #define PCINT1_vect			_VECTOR(7)
 
 
 /* Watchdog Timeout Interrupt */
+#define WDT_num 			8
 #define WDT_vect			_VECTOR(8)
 
 
 /* Wakeup timer overflow */
+#define WAKE_UP_num 			9
 #define WAKE_UP_vect			_VECTOR(9)
 
 
 /* Timer/Counter 1 Compare Match */
+#define TIM1_COMP_num 			10
 #define TIM1_COMP_vect			_VECTOR(10)
 
 
 /* Timer/Counter 1 Overflow */
+#define TIM1_OVF_num 			11
 #define TIM1_OVF_vect			_VECTOR(11)
 
 
 /* Timer/Counter0 Compare A Match */
+#define TIM0_COMPA_num 			12
 #define TIM0_COMPA_vect			_VECTOR(12)
 
 
 /* Timer/Counter0 Compare B Match */
+#define TIM0_COMPB_num 			13
 #define TIM0_COMPB_vect			_VECTOR(13)
 
 
 /* Timer/Counter0 Overflow */
+#define TIM0_OVF_num 			14
 #define TIM0_OVF_vect			_VECTOR(14)
 
 
 /* Two-Wire Bus Connect/Disconnect */
+#define TWI_BUS_CD_num 			15
 #define TWI_BUS_CD_vect			_VECTOR(15)
 
 
 /* Two-Wire Serial Interface */
+#define TWI_num 			16
 #define TWI_vect			_VECTOR(16)
 
 
 /* Voltage ADC Conversion Complete */
+#define VADC_num 			17
 #define VADC_vect			_VECTOR(17)
 
 
 /* Coulomb Counter ADC Conversion Complete */
+#define CCADC_CONV_num 			18
 #define CCADC_CONV_vect			_VECTOR(18)
 
 /* Coloumb Counter ADC Regular Current */
+#define CCADC_REG_CUR_num 		19
 #define CCADC_REG_CUR_vect		_VECTOR(19)
 
 
 /* Coloumb Counter ADC Accumulator */
+#define CCADC_ACC_num 			20
 #define CCADC_ACC_vect			_VECTOR(20)
 
 
 /* EEPROM Ready */
+#define EE_READY_num 			21
 #define EE_READY_vect			_VECTOR(21)
 
 
 /* Store Program Memory Ready */
+#define SPM_READY_num 			22
 #define SPM_READY_vect			_VECTOR(22)
 
 #define _VECTORS_SIZE 92
@@ -765,4 +788,146 @@
 #define SIGNATURE_2 0x07
 
 
+/* Device Pin Definitions */
+#define DDR_ADC0  	DDRA
+#define PORT_ADC0 	PORTA
+#define PIN_ADC0  	PINA
+#define ADC0_IDX  	0
+
+#define DDR_PCINT0  	DDRA
+#define PORT_PCINT0 	PORTA
+#define PIN_PCINT0  	PINA
+#define PCINT0_IDX  	0
+
+#define DDR_ADC1  	DDRA
+#define PORT_ADC1 	PORTA
+#define PIN_ADC1  	PINA
+#define ADC1_IDX  	1
+
+#define DDR_PCINT1  	DDRA
+#define PORT_PCINT1 	PORTA
+#define PIN_PCINT1  	PINA
+#define PCINT1_IDX  	1
+
+#define DDR_ADC2  	DDRA
+#define PORT_ADC2 	PORTA
+#define PIN_ADC2  	PINA
+#define ADC2_IDX  	2
+
+#define DDR_PCINT2  	DDRA
+#define PORT_PCINT2 	PORTA
+#define PIN_PCINT2  	PINA
+#define PCINT2_IDX  	2
+
+#define DDR_ADC3  	DDRA
+#define PORT_ADC3 	PORTA
+#define PIN_ADC3  	PINA
+#define ADC3_IDX  	3
+
+#define DDR_PCINT3  	DDRA
+#define PORT_PCINT3 	PORTA
+#define PIN_PCINT3  	PINA
+#define PCINT3_IDX  	3
+
+#define DDR_ADC4  	DDRA
+#define PORT_ADC4 	PORTA
+#define PIN_ADC4  	PINA
+#define ADC4_IDX  	4
+
+#define DDR_INT0  	DDRA
+#define PORT_INT0 	PORTA
+#define PIN_INT0  	PINA
+#define INT0_IDX  	4
+
+#define DDR_PCINT4  	DDRA
+#define PORT_PCINT4 	PORTA
+#define PIN_PCINT4  	PINA
+#define PCINT4_IDX  	4
+
+#define DDR_INT1  	DDRA
+#define PORT_INT1 	PORTA
+#define PIN_INT1  	PINA
+#define INT1_IDX  	5
+
+#define DDR_PCINT5  	DDRA
+#define PORT_PCINT5 	PORTA
+#define PIN_PCINT5  	PINA
+#define PCINT5_IDX  	5
+
+#define DDR_INT2  	DDRA
+#define PORT_INT2 	PORTA
+#define PIN_INT2  	PINA
+#define INT2_IDX  	6
+
+#define DDR_PCINT6  	DDRA
+#define PORT_PCINT6 	PORTA
+#define PIN_PCINT6  	PINA
+#define PCINT6_IDX  	6
+
+#define DDR_INT3  	DDRA
+#define PORT_INT3 	PORTA
+#define PIN_INT3  	PINA
+#define INT3_IDX  	7
+
+#define DDR_PCINT7  	DDRA
+#define PORT_PCINT7 	PORTA
+#define PIN_PCINT7  	PINA
+#define PCINT7_IDX  	7
+
+#define DDR_PCINT8  	DDRB
+#define PORT_PCINT8 	PORTB
+#define PIN_PCINT8  	PINB
+#define PCINT8_IDX  	0
+
+#define DDR_PCINT9  	DDRB
+#define PORT_PCINT9 	PORTB
+#define PIN_PCINT9  	PINB
+#define PCINT9_IDX  	1
+
+#define DDR_PCINT10  	DDRB
+#define PORT_PCINT10 	PORTB
+#define PIN_PCINT10  	PINB
+#define PCINT10_IDX  	2
+
+#define DDR_PCINT11  	DDRB
+#define PORT_PCINT11 	PORTB
+#define PIN_PCINT11  	PINB
+#define PCINT11_IDX  	3
+
+#define DDR_PCINT12  	DDRB
+#define PORT_PCINT12 	PORTB
+#define PIN_PCINT12  	PINB
+#define PCINT12_IDX  	4
+
+#define DDR_PCINT13  	DDRB
+#define PORT_PCINT13 	PORTB
+#define PIN_PCINT13  	PINB
+#define PCINT13_IDX  	5
+
+#define DDR_OC0A  	DDRB
+#define PORT_OC0A 	PORTB
+#define PIN_OC0A  	PINB
+#define OC0A_IDX  	6
+
+#define DDR_PCINT14  	DDRB
+#define PORT_PCINT14 	PORTB
+#define PIN_PCINT14  	PINB
+#define PCINT14_IDX  	6
+
+#define DDR_OC0B  	DDRB
+#define PORT_OC0B 	PORTB
+#define PIN_OC0B  	PINB
+#define OC0B_IDX  	7
+
+#define DDR_PCINT15  	DDRB
+#define PORT_PCINT15 	PORTB
+#define PIN_PCINT15  	PINB
+#define PCINT15_IDX  	7
+
+#define DDR_T0  	DDRD
+#define PORT_T0 	PORTD
+#define PIN_T0  	PIND
+#define T0_IDX  	0
+
+
 #endif /* _AVR_IOM406_H_ */
Index: include/avr/iom328p.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iom328p.h,v
retrieving revision 1.17
diff -u -r1.17 iom328p.h
--- include/avr/iom328p.h	11 Feb 2009 17:53:36 -0000	1.17
+++ include/avr/iom328p.h	26 Mar 2009 20:10:29 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2007 Atmel Corporation
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -786,30 +787,55 @@
 
 /* Interrupt Vectors */
 /* Interrupt Vector 0 is the reset vector. */
+#define INT0_num          1
 #define INT0_vect         _VECTOR(1)   /* External Interrupt Request 0 */
+#define INT1_num          2
 #define INT1_vect         _VECTOR(2)   /* External Interrupt Request 1 */
+#define PCINT0_num        3
 #define PCINT0_vect       _VECTOR(3)   /* Pin Change Interrupt Request 0 */
+#define PCINT1_num        4
 #define PCINT1_vect       _VECTOR(4)   /* Pin Change Interrupt Request 0 */
+#define PCINT2_num        5
 #define PCINT2_vect       _VECTOR(5)   /* Pin Change Interrupt Request 1 */
+#define WDT_num           6
 #define WDT_vect          _VECTOR(6)   /* Watchdog Time-out Interrupt */
+#define TIMER2_COMPA_num  7
 #define TIMER2_COMPA_vect _VECTOR(7)   /* Timer/Counter2 Compare Match A */
+#define TIMER2_COMPB_num  8
 #define TIMER2_COMPB_vect _VECTOR(8)   /* Timer/Counter2 Compare Match A */
+#define TIMER2_OVF_num    9
 #define TIMER2_OVF_vect   _VECTOR(9)   /* Timer/Counter2 Overflow */
+#define TIMER1_CAPT_num   10
 #define TIMER1_CAPT_vect  _VECTOR(10)  /* Timer/Counter1 Capture Event */
+#define TIMER1_COMPA_num  11
 #define TIMER1_COMPA_vect _VECTOR(11)  /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPB_num  12
 #define TIMER1_COMPB_vect _VECTOR(12)  /* Timer/Counter1 Compare Match B */ 
+#define TIMER1_OVF_num    13
 #define TIMER1_OVF_vect   _VECTOR(13)  /* Timer/Counter1 Overflow */
+#define TIMER0_COMPA_num  14
 #define TIMER0_COMPA_vect _VECTOR(14)  /* TimerCounter0 Compare Match A */
+#define TIMER0_COMPB_num  15
 #define TIMER0_COMPB_vect _VECTOR(15)  /* TimerCounter0 Compare Match B */
+#define TIMER0_OVF_num    16
 #define TIMER0_OVF_vect   _VECTOR(16)  /* Timer/Couner0 Overflow */
+#define SPI_STC_num       17
 #define SPI_STC_vect      _VECTOR(17)  /* SPI Serial Transfer Complete */
+#define USART_RX_num      18
 #define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
+#define USART_UDRE_num    19
 #define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
+#define USART_TX_num      20
 #define USART_TX_vect     _VECTOR(20)  /* USART Tx Complete */
+#define ADC_num           21
 #define ADC_vect          _VECTOR(21)  /* ADC Conversion Complete */
+#define EE_READY_num      22
 #define EE_READY_vect     _VECTOR(22)  /* EEPROM Ready */
+#define ANALOG_COMP_num   23
 #define ANALOG_COMP_vect  _VECTOR(23)  /* Analog Comparator */
+#define TWI_num           24
 #define TWI_vect          _VECTOR(24)  /* Two-wire Serial Interface */
+#define SPM_READY_num     25
 #define SPM_READY_vect    _VECTOR(25)  /* Store Program Memory Read */
 
 #define _VECTORS_SIZE (26 * 4)
@@ -872,4 +898,276 @@
 #define SIGNATURE_2 0x0F
 
 
+/* Device Pin Definitions */
+#define DDR_ICP1  	DDRB
+#define PORT_ICP1 	PORTB
+#define PIN_ICP1  	PINB
+#define ICP1_IDX  	0
+
+#define DDR_CLKO  	DDRB
+#define PORT_CLKO 	PORTB
+#define PIN_CLKO  	PINB
+#define CLKO_IDX  	0
+
+#define DDR_PCINT0  	DDRB
+#define PORT_PCINT0 	PORTB
+#define PIN_PCINT0  	PINB
+#define PCINT0_IDX  	0
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	1
+
+#define DDR_PCINT1  	DDRB
+#define PORT_PCINT1 	PORTB
+#define PIN_PCINT1  	PINB
+#define PCINT1_IDX  	1
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	2
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	2
+
+#define DDR_PCINT2  	DDRB
+#define PORT_PCINT2 	PORTB
+#define PIN_PCINT2  	PINB
+#define PCINT2_IDX  	2
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	3
+
+#define DDR_OC2A  	DDRB
+#define PORT_OC2A 	PORTB
+#define PIN_OC2A  	PINB
+#define OC2A_IDX  	3
+
+#define DDR_PCINT3  	DDRB
+#define PORT_PCINT3 	PORTB
+#define PIN_PCINT3  	PINB
+#define PCINT3_IDX  	3
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	4
+
+#define DDR_PCINT4  	DDRB
+#define PORT_PCINT4 	PORTB
+#define PIN_PCINT4  	PINB
+#define PCINT4_IDX  	4
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	5
+
+#define DDR_PCINT5  	DDRB
+#define PORT_PCINT5 	PORTB
+#define PIN_PCINT5  	PINB
+#define PCINT5_IDX  	5
+
+#define DDR_TOSC1  	DDRB
+#define PORT_TOSC1 	PORTB
+#define PIN_TOSC1  	PINB
+#define TOSC1_IDX  	6
+
+#define DDR_PCINT6  	DDRB
+#define PORT_PCINT6 	PORTB
+#define PIN_PCINT6  	PINB
+#define PCINT6_IDX  	6
+
+#define DDR_TOSC2  	DDRB
+#define PORT_TOSC2 	PORTB
+#define PIN_TOSC2  	PINB
+#define TOSC2_IDX  	7
+
+#define DDR_PCINT7  	DDRB
+#define PORT_PCINT7 	PORTB
+#define PIN_PCINT7  	PINB
+#define PCINT7_IDX  	7
+
+#define DDR_ADC0  	DDRC
+#define PORT_ADC0 	PORTC
+#define PIN_ADC0  	PINC
+#define ADC0_IDX  	0
+
+#define DDR_PCINT8  	DDRC
+#define PORT_PCINT8 	PORTC
+#define PIN_PCINT8  	PINC
+#define PCINT8_IDX  	0
+
+#define DDR_ADC1  	DDRC
+#define PORT_ADC1 	PORTC
+#define PIN_ADC1  	PINC
+#define ADC1_IDX  	1
+
+#define DDR_PCINT9  	DDRC
+#define PORT_PCINT9 	PORTC
+#define PIN_PCINT9  	PINC
+#define PCINT9_IDX  	1
+
+#define DDR_ADC2  	DDRC
+#define PORT_ADC2 	PORTC
+#define PIN_ADC2  	PINC
+#define ADC2_IDX  	2
+
+#define DDR_PCINT10  	DDRC
+#define PORT_PCINT10 	PORTC
+#define PIN_PCINT10  	PINC
+#define PCINT10_IDX  	2
+
+#define DDR_ADC3  	DDRC
+#define PORT_ADC3 	PORTC
+#define PIN_ADC3  	PINC
+#define ADC3_IDX  	3
+
+#define DDR_PCINT11  	DDRC
+#define PORT_PCINT11 	PORTC
+#define PIN_PCINT11  	PINC
+#define PCINT11_IDX  	3
+
+#define DDR_ADC4  	DDRC
+#define PORT_ADC4 	PORTC
+#define PIN_ADC4  	PINC
+#define ADC4_IDX  	4
+
+#define DDR_SDA  	DDRC
+#define PORT_SDA 	PORTC
+#define PIN_SDA  	PINC
+#define SDA_IDX  	4
+
+#define DDR_PCINT12  	DDRC
+#define PORT_PCINT12 	PORTC
+#define PIN_PCINT12  	PINC
+#define PCINT12_IDX  	4
+
+#define DDR_ADC5  	DDRC
+#define PORT_ADC5 	PORTC
+#define PIN_ADC5  	PINC
+#define ADC5_IDX  	5
+
+#define DDR_SCL  	DDRC
+#define PORT_SCL 	PORTC
+#define PIN_SCL  	PINC
+#define SCL_IDX  	5
+
+#define DDR_PCINT13  	DDRC
+#define PORT_PCINT13 	PORTC
+#define PIN_PCINT13  	PINC
+#define PCINT13_IDX  	5
+
+#define DDR_PCINT14  	DDRC
+#define PORT_PCINT14 	PORTC
+#define PIN_PCINT14  	PINC
+#define PCINT14_IDX  	6
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_PCINT16  	DDRD
+#define PORT_PCINT16 	PORTD
+#define PIN_PCINT16  	PIND
+#define PCINT16_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_PCINT17  	DDRD
+#define PORT_PCINT17 	PORTD
+#define PIN_PCINT17  	PIND
+#define PCINT17_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_PCINT18  	DDRD
+#define PORT_PCINT18 	PORTD
+#define PIN_PCINT18  	PIND
+#define PCINT18_IDX  	2
+
+#define DDR_PCINT19  	DDRD
+#define PORT_PCINT19 	PORTD
+#define PIN_PCINT19  	PIND
+#define PCINT19_IDX  	3
+
+#define DDR_OC2B  	DDRD
+#define PORT_OC2B 	PORTD
+#define PIN_OC2B  	PIND
+#define OC2B_IDX  	3
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_XCK  	DDRD
+#define PORT_XCK 	PORTD
+#define PIN_XCK  	PIND
+#define XCK_IDX  	4
+
+#define DDR_T0  	DDRD
+#define PORT_T0 	PORTD
+#define PIN_T0  	PIND
+#define T0_IDX  	4
+
+#define DDR_PCINT20  	DDRD
+#define PORT_PCINT20 	PORTD
+#define PIN_PCINT20  	PIND
+#define PCINT20_IDX  	4
+
+#define DDR_T1  	DDRD
+#define PORT_T1 	PORTD
+#define PIN_T1  	PIND
+#define T1_IDX  	5
+
+#define DDR_OC0B  	DDRD
+#define PORT_OC0B 	PORTD
+#define PIN_OC0B  	PIND
+#define OC0B_IDX  	5
+
+#define DDR_PCINT21  	DDRD
+#define PORT_PCINT21 	PORTD
+#define PIN_PCINT21  	PIND
+#define PCINT21_IDX  	5
+
+#define DDR_AIN0  	DDRD
+#define PORT_AIN0 	PORTD
+#define PIN_AIN0  	PIND
+#define AIN0_IDX  	6
+
+#define DDR_OC0A  	DDRD
+#define PORT_OC0A 	PORTD
+#define PIN_OC0A  	PIND
+#define OC0A_IDX  	6
+
+#define DDR_PCINT22  	DDRD
+#define PORT_PCINT22 	PORTD
+#define PIN_PCINT22  	PIND
+#define PCINT22_IDX  	6
+
+#define DDR_AIN1  	DDRD
+#define PORT_AIN1 	PORTD
+#define PIN_AIN1  	PIND
+#define AIN1_IDX  	7
+
+#define DDR_PCINT23  	DDRD
+#define PORT_PCINT23 	PORTD
+#define PIN_PCINT23  	PIND
+#define PCINT23_IDX  	7
+
+
 #endif  /* _AVR_IOM328P_H_ */
